package org.jboss.soa.esb.samples.quickstart.helloworld_ejb3;

import javax.annotation.Resource;
import javax.annotation.security.PermitAll;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;
import javax.jws.WebService;

import org.jboss.annotation.security.SecurityDomain;
import org.jboss.soa.esb.client.ServiceInvoker;
import org.jboss.soa.esb.listeners.message.MessageDeliverException;
import org.jboss.soa.esb.message.Message;
import org.jboss.soa.esb.message.format.MessageFactory;

@WebService(serviceName = "HelloWorldWS-WSS", endpointInterface = "org.jboss.soa.esb.samples.quickstart.helloworld_ejb3.HelloWorldEjbWSWSS")
@Stateless
public class HelloWorldEjbWSWSSBean implements HelloWorldEjbWSWSS{

	@Resource SessionContext wsCtx;
	
	@PermitAll
	public void sayHello() {
		
		try {
	
			ServiceInvoker invoker = new ServiceInvoker("QuickStart","HelloworldEjb3WSWSS");
			Message message = MessageFactory.getInstance().getMessage();
			
			
			message.getBody().add("Hello " + wsCtx.getCallerPrincipal().getName());
			invoker.deliverAsync(message);
			
	
		} catch (MessageDeliverException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}
